#include<bits\stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    long long n, q, tp2 = 1;
    cin>>n>>q;
    long long a[n], e[q];
    for(long long i = 0; i < n; i++)
    {
        cin>>a[i];
        if(a[i] > 1)
        {
            tp2 = 0;
        }
    }
    for(long long i = 0; i < q; i++)
    {
        long long l, r;
        cin>>l>>r;
        l -= 1;
        r -= 1;
        if(tp2 == 0)
        {
            e[i] = a[l];
            for(long long j = l + 1; j <= r; j++)
            {
                e[i] = e[i] & a[j];
                if(e[i] == 0)
                {
                    j = r + 1;
                }
            }
        }
        else
        {
            e[i] = 1;
            for(long long j = l; j <= r; j++)
            {
                if(!a[j])
                {
                    e[i] = 0;
                    break;
                }
            }
        }
    }
    for(long long i = 0; i < q; i++)
    {
        cout<<e[i]<<endl;
    }
}